#!/bin/bash
#
# packager                          : Frederic Boulet <bipbip> bipbiponlinux~AT~gmail.com
#
# o trouver les sources : http://sourceforge.net/project/showfiles.php?group_id=130986
#
# dernires rvisions       : 4/10/2007
#
# fichiers additionnels :
#

softname='vamps'
softversion='0.99.2'
packageversion='48.1'

#
# ZenWalk standard: type CPUet architecture
#
# arch='i486' -> le compileur utilise seulement les instructions 80486
# cpu='i686'  -> optimisation fate pour PII et >
#
arch='i486'
cpu='i686'

#
# destination du package
#
prefix=/usr
#
# building-computer dependent: the number of parallel 'jobs' of 'make'
#
# "gros" PC: 6 compilations  la fois
#
# numjobs='-j6'
#
# "lger" PC: 2 compilations  la fois
#
numjobs='-j2'

#
# paramtres pour compiler
#
buildir=$(pwd)
srcpkg="$buildir/$softname-$softversion.tar.gz"
src="$buildir/$softname-$softversion"
package="$softname-$softversion-$arch-$packageversion"
dest="$buildir/$package"

#
# preparer le rpertoire qui accueillera la compilation
#
rm -rf $dest
mkdir -p $dest
mkdir -p $dest/install
mkdir -p $dest/$prefix/bin
mkdir -p $dest/usr/src/$softname-$softversion

#
# mettre le slack-desc en place. 
#
cat <<EOF > $dest/install/slack-desc
     |-----handy-ruler------------------------------------------------------|
vamps: $softname
vamps:
vamps: Vamps is a tool to help backing up DVDs
vamps: Vamps evaporates DVD compliant MPEG2 program
vamps: streams by selectively copying audio
vamps: and subpicture tracks and by re-quantizing
vamps: the video stream.
vamps:
vamps: 
vamps:
vamps: 
EOF

#
# extraire les sources
#
# tar.gz : tar zxvf $srcpkg
# tar.bz2: tar xjvf $srcpkg
# tgz    : tar xzvf $srcpkg
#
cd $buildir
tar xvzf $srcpkg
cd $src

#
# "faire" le package package
#
    sed -i -e 's|-pipe -O3|-pipe -O2 -march=i486 -mtune=i686|g' vamps/Makefile    
    make $numjobs DESTDIR=$dest

#
# installer le package dans son rpertoire de destination
#
    cp $src/play_cell/play_cell $dest/$prefix/bin
    cp $src/vamps/vamps $dest/$prefix/bin
    
#
# ajout des fichiers de docs, infos, ...
#
    mkdir -p $dest/usr/doc/$softname-$softversion
    cp -a \
      COPYING INSTALL\
      $dest/usr/doc/$softname-$softversion

#
# Stripper les xcutables
# (Commenter ces lignes si besoin d'infos de dbuggage)
#
( cd $dest
  find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
  find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
)

#
# Mettre le zenbuild  sa place
#
cd $buildir
cp build-$softname.sh $dest/$prefix/src/$softname-$softversion

#
# fixer les permissions
#
chown -R root.root $dest

cd $dest
find . -perm 664 -exec chmod 644 {} \;
find . -perm 600 -exec chmod 644 {} \;
find . -perm 444 -exec chmod 644 {} \;
find . -perm 400 -exec chmod 644 {} \;
find . -perm 440 -exec chmod 644 {} \;
find . -perm 777 -exec chmod 755 {} \;
find . -perm 775 -exec chmod 755 {} \;
find . -perm 511 -exec chmod 755 {} \;
find . -perm 711 -exec chmod 755 {} \;
find . -perm 555 -exec chmod 755 {} \;

#
# fabriquer le zenpackage
#
cd $dest
makepkg -l y -c n $dest.tgz

#
# produire la signature md5 du package
#
cd $buildir
md5sum $package.tgz > $package.md5

#
# produire le fichier .dep
#
cd $buildir
echo -e "libdvdcss,libdvdread" > $package.dep

#
# supprimer source
#
rm -rf $src
rm -rf $dest
